diff -Naur -x .svn stamp-0.9.10/labyrinth/Makefile.hle_intel stamp-0.9.10_Distribute/labyrinth/Makefile.hle_intel
--- stamp-0.9.10/labyrinth/Makefile.hle_intel	1970-01-01 09:00:00.000000000 +0900
+++ stamp-0.9.10_Distribute/labyrinth/Makefile.hle_intel	2014-12-18 12:39:02.784566989 +0900
@@ -0,0 +1,18 @@
+# ==============================================================================
+#
+# Makefile.hle_intel
+#
+# ==============================================================================
+# Copyright (c) IBM Corp. 2014, and others.
+
+
+include ../common/Defines.common.mk
+include ./Defines.common.mk
+include ../common/Makefile.hle_intel
+
+# ==============================================================================
+#
+# Makefile.hle_intel
+#
+# ==============================================================================
+
diff -Naur -x .svn stamp-0.9.10/labyrinth/Makefile.htm_ibm stamp-0.9.10_Distribute/labyrinth/Makefile.htm_ibm
--- stamp-0.9.10/labyrinth/Makefile.htm_ibm	1970-01-01 09:00:00.000000000 +0900
+++ stamp-0.9.10_Distribute/labyrinth/Makefile.htm_ibm	2014-12-18 12:39:14.282622267 +0900
@@ -0,0 +1,18 @@
+# ==============================================================================
+#
+# Makefile.htm_ibm
+#
+# ==============================================================================
+# Copyright (c) IBM Corp. 2014, and others.
+
+
+include ../common/Defines.common.mk
+include ./Defines.common.mk
+include ../common/Makefile.htm_ibm
+
+# ==============================================================================
+#
+# Makefile.htm_ibm
+#
+# ==============================================================================
+
diff -Naur -x .svn stamp-0.9.10/labyrinth/router.c stamp-0.9.10_Distribute/labyrinth/router.c
--- stamp-0.9.10/labyrinth/router.c	2008-09-09 07:42:38.000000000 +0900
+++ stamp-0.9.10_Distribute/labyrinth/router.c	2014-12-18 12:20:47.050592473 +0900
@@ -67,6 +67,7 @@
  *
  * =============================================================================
  */
+/* Copyright (c) IBM Corp. 2014. */
 
 
 #include <assert.h>
@@ -376,7 +377,7 @@
     while (1) {
 
         pair_t* coordinatePairPtr;
-        TM_BEGIN();
+        TM_BEGIN_ID(0);
         if (TMQUEUE_ISEMPTY(workQueuePtr)) {
             coordinatePairPtr = NULL;
         } else {
@@ -393,7 +394,7 @@
         bool_t success = FALSE;
         vector_t* pointVectorPtr = NULL;
 
-        TM_BEGIN();
+        TM_BEGIN_ID(1);
         grid_copy(myGridPtr, gridPtr); /* ok if not most up-to-date */
         if (PdoExpansion(routerPtr, myGridPtr, myExpansionQueuePtr,
                          srcPtr, dstPtr)) {
@@ -422,7 +423,7 @@
      * Add my paths to global list
      */
     list_t* pathVectorListPtr = routerArgPtr->pathVectorListPtr;
-    TM_BEGIN();
+    TM_BEGIN_ID(2);
     TMLIST_INSERT(pathVectorListPtr, (void*)myPathVectorPtr);
     TM_END();
 
diff -Naur -x .svn stamp-0.9.10/lib/bitmap.c stamp-0.9.10_Distribute/lib/bitmap.c
--- stamp-0.9.10/lib/bitmap.c	2008-09-09 07:42:39.000000000 +0900
+++ stamp-0.9.10_Distribute/lib/bitmap.c	2014-12-18 12:20:56.962723495 +0900
@@ -67,6 +67,7 @@
  *
  * =============================================================================
  */
+/* Copyright (c) IBM Corp. 2014. */
 
 
 #include <assert.h>
@@ -98,7 +99,11 @@
     }
 
     bitmapPtr->numBit = numBit;
+#ifdef __GNUC__
     long numWord = DIVIDE_AND_ROUND_UP(numBit, NUM_BIT_PER_WORD);
+#else
+    long numWord = DIVIDE_AND_ROUND_UP_nogcc(numBit, NUM_BIT_PER_WORD);
+#endif
     bitmapPtr->numWord = numWord;
 
     bitmapPtr->bits = (ulong_t*)malloc(numWord * sizeof(ulong_t));
@@ -127,7 +132,11 @@
     }
 
     bitmapPtr->numBit = numBit;
+#ifdef __GNUC__
     long numWord = DIVIDE_AND_ROUND_UP(numBit, NUM_BIT_PER_WORD);
+#else
+    long numWord = DIVIDE_AND_ROUND_UP_nogcc(numBit, NUM_BIT_PER_WORD);
+#endif
     bitmapPtr->numWord = numWord;
 
     bitmapPtr->bits = (ulong_t*)P_MALLOC(numWord * sizeof(ulong_t));
@@ -264,7 +273,11 @@
     long numBit = bitmapPtr->numBit;
     ulong_t* bits = bitmapPtr->bits;
 
+#ifdef __GNUC__
     for (i = MAX(startIndex, 0); i < numBit; i++) {
+#else
+    for (i = MAX_nogcc(startIndex, 0); i < numBit; i++) {
+#endif
         if (!(bits[i/NUM_BIT_PER_WORD] & (1UL << (i % NUM_BIT_PER_WORD)))) {
             return i;
         }
@@ -288,7 +301,11 @@
     long numBit = bitmapPtr->numBit;
     ulong_t* bits = bitmapPtr->bits;
 
+#ifdef __GNUC__
     for (i = MAX(startIndex, 0); i < numBit; i++) {
+#else
+    for (i = MAX_nogcc(startIndex, 0); i < numBit; i++) {
+#endif
         if (bits[i/NUM_BIT_PER_WORD] & (1UL << (i % NUM_BIT_PER_WORD))) {
             return i;
         }
@@ -388,7 +405,11 @@
     bitmapPtr = bitmap_alloc(numBit);
 
     assert(bitmapPtr->numBit == numBit);
+#ifdef __GNUC__
     assert(bitmapPtr->numWord == (DIVIDE_AND_ROUND_UP(numBit, NUM_BIT_PER_WORD)));
+#else
+    assert(bitmapPtr->numWord == (DIVIDE_AND_ROUND_UP_nogcc(numBit, NUM_BIT_PER_WORD)));
+#endif
 
     /* Check that initial is all clear */
     for (i = 0; i < numBit; i++) {
diff -Naur -x .svn stamp-0.9.10/lib/conc_hashtable.c stamp-0.9.10_Distribute/lib/conc_hashtable.c
--- stamp-0.9.10/lib/conc_hashtable.c	1970-01-01 09:00:00.000000000 +0900
+++ stamp-0.9.10_Distribute/lib/conc_hashtable.c	2014-12-18 12:21:04.570632755 +0900
@@ -0,0 +1,220 @@
+/* Copyright (c) IBM Corp. 2014. */
+#include <stdlib.h>
+#include <stdint.h>
+#include "conc_hashtable.h"
+#include "types.h"
+
+#ifdef HAVE_CONFIG_H
+# include "STAMP_config.h"
+#endif
+
+#if defined( __370__)
+#define CACHE_LINE_SIZE 256
+#elif defined(__bgq__)
+#define CACHE_LINE_SIZE 128
+#elif defined(__PPC__) || defined(_ARCH_PPC)
+#define CACHE_LINE_SIZE 128
+#elif defined(__x86_64__)
+#define CACHE_LINE_SIZE 64
+#else
+#define CACHE_LINE_SIZE 32
+#endif
+
+#define ALIGNED_HASHTABLE_SIZE ((sizeof(hashtable_t) + CACHE_LINE_SIZE - 1) & ~(CACHE_LINE_SIZE - 1))
+
+#define NUM_SEGMENTS 31
+#define GET_SEGMENT(seg, idx) ((hashtable_t *)((char *)(seg) + ALIGNED_HASHTABLE_SIZE * (idx)))
+
+static ulong_t
+hashKeyDefault(const void *a)
+{
+    return (ulong_t)a;
+}
+
+static long
+comparePairsDefault (const pair_t* a, const pair_t* b)
+{
+    return ((long)(a->firstPtr) - (long)(b->firstPtr));
+}
+
+conc_hashtable_t*
+conc_hashtable_alloc (long initNumBucket,
+		      ulong_t (*hash)(const void*),
+		      long (*comparePairs)(const pair_t*, const pair_t*),
+		      long resizeRatio,
+		      long growthFactor)
+{
+    conc_hashtable_t *concHashtablePtr;
+    char *segmentsUnaligned;
+    char *segments;
+    int s;
+
+    if (hash == NULL) {
+	hash = hashKeyDefault;
+    }
+    if (comparePairs == NULL) {
+	comparePairs = comparePairsDefault;
+    }
+
+    concHashtablePtr = (conc_hashtable_t *)malloc(sizeof(conc_hashtable_t));
+    if (concHashtablePtr == NULL) {
+	return NULL;
+    }
+
+    concHashtablePtr->hash = hash;
+
+    segmentsUnaligned = (char *)malloc(sizeof(char) * ALIGNED_HASHTABLE_SIZE * NUM_SEGMENTS + CACHE_LINE_SIZE);
+    if (segmentsUnaligned == NULL) {
+	return NULL;
+    }
+    segments = (char *)(((uintptr_t)segmentsUnaligned + CACHE_LINE_SIZE - 1) & ~(CACHE_LINE_SIZE - 1));
+
+    concHashtablePtr->segmentsUnaligned = segmentsUnaligned;
+    concHashtablePtr->segments = segments;
+
+    for (s = 0; s < NUM_SEGMENTS; s++) {
+	if (hashtable_init(GET_SEGMENT(segments, s),
+			   initNumBucket, hash, comparePairs, resizeRatio, growthFactor)) {
+	    free(concHashtablePtr);
+	    return NULL;
+	}
+    }
+
+    return concHashtablePtr;
+}
+
+void
+conc_hashtable_free (conc_hashtable_t* concHashtablePtr)
+{
+    int s;
+
+    for (s = 0; s < NUM_SEGMENTS; s++) {
+	hashtable_free_buckets(GET_SEGMENT(concHashtablePtr->segments, s));
+    }
+
+    free(concHashtablePtr->segmentsUnaligned);
+    free(concHashtablePtr);
+}
+
+bool_t
+conc_hashtable_containsKey (conc_hashtable_t* concHashtablePtr, void* keyPtr)
+{
+    long i = concHashtablePtr->hash(keyPtr) % NUM_SEGMENTS;
+    return hashtable_containsKey(GET_SEGMENT(concHashtablePtr->segments, i), keyPtr);
+}
+
+
+void*
+conc_hashtable_find (conc_hashtable_t* concHashtablePtr, void* keyPtr)
+{
+    long i = concHashtablePtr->hash(keyPtr) % NUM_SEGMENTS;
+    return hashtable_find(GET_SEGMENT(concHashtablePtr->segments, i), keyPtr);
+}
+
+bool_t
+conc_hashtable_insert (conc_hashtable_t* concHashtablePtr, void* keyPtr, void* dataPtr)
+{
+    long i = concHashtablePtr->hash(keyPtr) % NUM_SEGMENTS;
+    return hashtable_insert(GET_SEGMENT(concHashtablePtr->segments, i), keyPtr, dataPtr);
+}
+
+bool_t
+conc_hashtable_remove (conc_hashtable_t* concHashtablePtr, void* keyPtr)
+{
+    long i = concHashtablePtr->hash(keyPtr) % NUM_SEGMENTS;
+    return hashtable_remove(GET_SEGMENT(concHashtablePtr->segments, i), keyPtr);
+}
+
+
+
+conc_hashtable_t*
+TMconc_hashtable_alloc (TM_ARGDECL  long initNumBucket,
+			ulong_t (*hash)(const void*),
+			long (*comparePairs)(const pair_t*, const pair_t*),
+			long resizeRatio,
+			long growthFactor)
+{
+    conc_hashtable_t *concHashtablePtr;
+    char *segmentsUnaligned;
+    char *segments;
+    int s;
+
+    if (hash == NULL) {
+	hash = hashKeyDefault;
+    }
+    if (comparePairs == NULL) {
+	comparePairs = comparePairsDefault;
+    }
+
+    /* This will be freed only by TMconc_hashtable_free(),
+       so it can be allocated by malloc(), not TM_MALLOC(). */
+    concHashtablePtr = (conc_hashtable_t *)malloc(sizeof(conc_hashtable_t));
+    if (concHashtablePtr == NULL) {
+	return NULL;
+    }
+
+    concHashtablePtr->hash = hash;
+
+    /* This will be freed only by TMconc_hashtable_free(),
+       so it can be allocated by malloc(), not TM_MALLOC(). */
+    segmentsUnaligned = (char *)malloc(sizeof(char) * ALIGNED_HASHTABLE_SIZE * NUM_SEGMENTS + CACHE_LINE_SIZE);
+    if (segmentsUnaligned == NULL) {
+	return NULL;
+    }
+    segments = (char *)(((uintptr_t)segmentsUnaligned + CACHE_LINE_SIZE - 1) & ~(CACHE_LINE_SIZE - 1));
+
+    concHashtablePtr->segmentsUnaligned = segmentsUnaligned;
+    concHashtablePtr->segments = segments;
+
+    for (s = 0; s < NUM_SEGMENTS; s++) {
+	if (TMhashtable_init(TM_ARG  GET_SEGMENT(segments, s),
+			     initNumBucket, hash, comparePairs, resizeRatio, growthFactor)) {
+	    free(concHashtablePtr);
+	    return NULL;
+	}
+    }
+
+    return concHashtablePtr;
+}
+
+void
+TMconc_hashtable_free (TM_ARGDECL  conc_hashtable_t* concHashtablePtr)
+{
+    int s;
+
+    for (s = 0; s < NUM_SEGMENTS; s++) {
+	TMhashtable_free_buckets(TM_ARG  GET_SEGMENT(concHashtablePtr->segments, s));
+    }
+
+    free(concHashtablePtr->segmentsUnaligned);
+    free(concHashtablePtr);
+}
+
+bool_t
+TMconc_hashtable_containsKey (TM_ARGDECL  conc_hashtable_t* concHashtablePtr, void* keyPtr)
+{
+    long i = concHashtablePtr->hash(keyPtr) % NUM_SEGMENTS;
+    return TMhashtable_containsKey(TM_ARG  GET_SEGMENT(concHashtablePtr->segments, i), keyPtr);
+}
+
+
+void*
+TMconc_hashtable_find (TM_ARGDECL  conc_hashtable_t* concHashtablePtr, void* keyPtr)
+{
+    long i = concHashtablePtr->hash(keyPtr) % NUM_SEGMENTS;
+    return TMHASHTABLE_FIND(GET_SEGMENT(concHashtablePtr->segments, i), keyPtr);
+}
+
+bool_t
+TMconc_hashtable_insert (TM_ARGDECL  conc_hashtable_t* concHashtablePtr, void* keyPtr, void* dataPtr)
+{
+    long i = concHashtablePtr->hash(keyPtr) % NUM_SEGMENTS;
+    return TMHASHTABLE_INSERT(GET_SEGMENT(concHashtablePtr->segments, i), keyPtr, dataPtr);
+}
+
+bool_t
+TMconc_hashtable_remove (TM_ARGDECL  conc_hashtable_t* concHashtablePtr, void* keyPtr)
+{
+    long i = concHashtablePtr->hash(keyPtr) % NUM_SEGMENTS;
+    return TMHASHTABLE_REMOVE(GET_SEGMENT(concHashtablePtr->segments, i), keyPtr);
+}
diff -Naur -x .svn stamp-0.9.10/lib/conc_hashtable.h stamp-0.9.10_Distribute/lib/conc_hashtable.h
--- stamp-0.9.10/lib/conc_hashtable.h	1970-01-01 09:00:00.000000000 +0900
+++ stamp-0.9.10_Distribute/lib/conc_hashtable.h	2014-12-18 12:21:09.247782526 +0900
@@ -0,0 +1,78 @@
+/* Copyright (c) IBM Corp. 2014. */
+#ifndef CONC_HASHTABLE_H
+#define CONC_HASHTABLE_H 1
+
+#include "hashtable.h"
+
+#ifdef __cplusplus
+extern "C" {
+#endif
+
+typedef struct conc_hashtable {
+    char *segments;
+    char *segmentsUnaligned;
+    ulong_t (*hash)(const void*);
+} conc_hashtable_t;
+
+conc_hashtable_t*
+conc_hashtable_alloc (long initNumBucket,
+		      ulong_t (*hash)(const void*),
+		      long (*comparePairs)(const pair_t*, const pair_t*),
+		      long resizeRatio,
+		      long growthFactor);
+
+void
+conc_hashtable_free (conc_hashtable_t* concHashtablePtr);
+
+bool_t
+conc_hashtable_containsKey (conc_hashtable_t* concHashtablePtr, void* keyPtr);
+
+void*
+conc_hashtable_find (conc_hashtable_t* concHashtablePtr, void* keyPtr);
+
+bool_t
+conc_hashtable_insert (conc_hashtable_t* concHashtablePtr, void* keyPtr, void* dataPtr);
+
+bool_t
+conc_hashtable_remove (conc_hashtable_t* concHashtablePtr, void* keyPtr);
+
+
+
+conc_hashtable_t*
+TMconc_hashtable_alloc (TM_ARGDECL
+			long initNumBucket,
+			ulong_t (*hash)(const void*),
+			long (*comparePairs)(const pair_t*, const pair_t*),
+			long resizeRatio,
+			long growthFactor);
+
+void
+TMconc_hashtable_free (TM_ARGDECL  conc_hashtable_t* concHashtablePtr);
+
+bool_t
+TMconc_hashtable_containsKey (TM_ARGDECL  conc_hashtable_t* concHashtablePtr, void* keyPtr);
+
+void*
+TMconc_hashtable_find (TM_ARGDECL  conc_hashtable_t* concHashtablePtr, void* keyPtr);
+
+bool_t
+TMconc_hashtable_insert (TM_ARGDECL  conc_hashtable_t* concHashtablePtr, void* keyPtr, void* dataPtr);
+
+bool_t
+TMconc_hashtable_remove (TM_ARGDECL  conc_hashtable_t* concHashtablePtr, void* keyPtr);
+
+
+
+#define TMCONC_HASHTABLE_ALLOC(i, h, c, r, g)  TMconc_hashtable_alloc(TM_ARG  i, h, c, r, g)
+#define TMCONC_HASHTABLE_FREE(ht)              TMconc_hashtable_free(TM_ARG  ht)
+#define TMCONC_HASHTABLE_CONTAINSKEY(ht, k)    TMconc_hashtable_containsKey(TM_ARG ht, k)
+#define TMCONC_HASHTABLE_FIND(ht, k)           TMconc_hashtable_find(TM_ARG ht, k)
+#define TMCONC_HASHTABLE_INSERT(ht, k, d)      TMconc_hashtable_insert(TM_ARG ht, k, d)
+#define TMCONC_HASHTABLE_REMOVE(ht, k)         TMconc_hashtable_remove(TM_ARG ht, k)
+
+#ifdef __cplusplus
+}
+#endif
+
+
+#endif /* CONC_HASHTABLE_H */
diff -Naur -x .svn stamp-0.9.10/lib/hashtable.c stamp-0.9.10_Distribute/lib/hashtable.c
--- stamp-0.9.10/lib/hashtable.c	2008-09-09 07:42:39.000000000 +0900
+++ stamp-0.9.10_Distribute/lib/hashtable.c	2014-12-18 12:21:26.959755208 +0900
@@ -79,6 +79,7 @@
  *
  * =============================================================================
  */
+/* Copyright (c) IBM Corp. 2014. */
 
 
 #include <assert.h>
@@ -93,7 +94,7 @@
 #endif
 
 #if defined(HASHTABLE_RESIZABLE) && (defined(HTM) || defined(STM))
-#  warning "hash table resizing currently disabled for TM"
+/*#  warning "hash table resizing currently disabled for TM"*/
 #endif
 
 
@@ -343,6 +344,33 @@
     return hashtablePtr;
 }
 
+int
+hashtable_init (hashtable_t* hashtablePtr,
+		long initNumBucket,
+		ulong_t (*hash)(const void*),
+		long (*comparePairs)(const pair_t*, const pair_t*),
+		long resizeRatio,
+		long growthFactor)
+{
+    hashtablePtr->buckets = allocBuckets(initNumBucket, comparePairs);
+    if (hashtablePtr->buckets == NULL) {
+        return 1;
+    }
+
+    hashtablePtr->numBucket = initNumBucket;
+#ifdef HASHTABLE_SIZE_FIELD
+    hashtablePtr->size = 0;
+#endif
+    hashtablePtr->hash = hash;
+    hashtablePtr->comparePairs = comparePairs;
+    hashtablePtr->resizeRatio = ((resizeRatio < 0) ?
+                                  HASHTABLE_DEFAULT_RESIZE_RATIO : resizeRatio);
+    hashtablePtr->growthFactor = ((growthFactor < 0) ?
+                                  HASHTABLE_DEFAULT_GROWTH_FACTOR : growthFactor);
+
+    return 0;
+}
+
 
 /* =============================================================================
  * TMhashtable_alloc
@@ -385,6 +413,34 @@
     return hashtablePtr;
 }
 
+int
+TMhashtable_init (TM_ARGDECL
+		  hashtable_t* hashtablePtr,
+		  long initNumBucket,
+		  ulong_t (*hash)(const void*),
+		  long (*comparePairs)(const pair_t*, const pair_t*),
+		  long resizeRatio,
+		  long growthFactor)
+{
+    hashtablePtr->buckets = TMallocBuckets(TM_ARG  initNumBucket, comparePairs);
+    if (hashtablePtr->buckets == NULL) {
+        return 1;
+    }
+
+    hashtablePtr->numBucket = initNumBucket;
+#ifdef HASHTABLE_SIZE_FIELD
+    hashtablePtr->size = 0;
+#endif
+    hashtablePtr->hash = hash;
+    hashtablePtr->comparePairs = comparePairs;
+    hashtablePtr->resizeRatio = ((resizeRatio < 0) ?
+                                  HASHTABLE_DEFAULT_RESIZE_RATIO : resizeRatio);
+    hashtablePtr->growthFactor = ((growthFactor < 0) ?
+                                  HASHTABLE_DEFAULT_GROWTH_FACTOR : growthFactor);
+
+    return 0;
+}
+
 
 /* =============================================================================
  * freeBuckets
@@ -431,6 +487,12 @@
     free(hashtablePtr);
 }
 
+void
+hashtable_free_buckets (hashtable_t* hashtablePtr)
+{
+    freeBuckets(hashtablePtr->buckets, hashtablePtr->numBucket);
+}
+
 
 /* =============================================================================
  * TMhashtable_free
@@ -443,6 +505,13 @@
     TM_FREE(hashtablePtr);
 }
 
+void
+TMhashtable_free_buckets (TM_ARGDECL  hashtable_t* hashtablePtr)
+{
+    /*printf("numBucket %ld  size %ld\n", hashtablePtr->numBucket, hashtablePtr->size);*/
+    TMfreeBuckets(TM_ARG  hashtablePtr->buckets, hashtablePtr->numBucket);
+}
+
 
 /* =============================================================================
  * hashtable_isEmpty
@@ -616,7 +685,10 @@
 }
 
 
-#if defined(HASHTABLE_RESIZABLE) && !(defined(HTM) || defined(STM))
+/* Modified by Odaira begin */
+#if defined(HASHTABLE_RESIZABLE)
+/*#if defined(HASHTABLE_RESIZABLE) && !(defined(HTM) || defined(STM) || defined(HTM_IBM) || defined(HLE_INTEL))*/
+/* Modified by Odaira end */
 /* =============================================================================
  * rehash
  * =============================================================================
@@ -652,6 +724,42 @@
 }
 #endif /* HASHTABLE_RESIZABLE */
 
+#if defined(HASHTABLE_RESIZABLE)
+/* =============================================================================
+ * TMrehash
+ * =============================================================================
+ */
+static list_t**
+TMrehash (TM_ARGDECL  hashtable_t* hashtablePtr)
+{
+    list_t** oldBuckets = TM_SHARED_READ(hashtablePtr->buckets);
+    long oldNumBucket = TM_SHARED_READ(hashtablePtr->numBucket);
+    long newNumBucket = hashtablePtr->growthFactor * oldNumBucket;
+    list_t** newBuckets;
+    long i;
+
+    newBuckets = TMallocBuckets(TM_ARG  newNumBucket, hashtablePtr->comparePairs);
+    if (newBuckets == NULL) {
+        return NULL;
+    }
+
+    for (i = 0; i < oldNumBucket; i++) {
+        list_t* chainPtr = TM_SHARED_READ(oldBuckets[i]);
+        list_iter_t it;
+        TMLIST_ITER_RESET(&it, chainPtr);
+        while (TMLIST_ITER_HASNEXT(&it, chainPtr)) {
+            pair_t* transferPtr = (pair_t*)TMLIST_ITER_NEXT(&it, chainPtr);
+            long j = hashtablePtr->hash(transferPtr->firstPtr) % newNumBucket;
+            if (TMLIST_INSERT(newBuckets[j], (void*)transferPtr) == FALSE) {
+                return NULL;
+            }
+        }
+    }
+
+    return newBuckets;
+}
+#endif /* HASHTABLE_RESIZABLE */
+
 
 /* =============================================================================
  * hashtable_insert
@@ -723,12 +831,24 @@
 TMhashtable_insert (TM_ARGDECL
                     hashtable_t* hashtablePtr, void* keyPtr, void* dataPtr)
 {
+#ifdef HASHTABLE_SIZE_FIELD
+    long numBucket = TM_SHARED_READ(hashtablePtr->numBucket);
+#else
     long numBucket = hashtablePtr->numBucket;
+#endif
     long i = hashtablePtr->hash(keyPtr) % numBucket;
+#if defined(HASHTABLE_SIZE_FIELD) || defined(HASHTABLE_RESIZABLE)
+    long newSize;
+#endif
 
     pair_t findPair;
     findPair.firstPtr = keyPtr;
+#ifdef HASHTABLE_SIZE_FIELD
+    list_t **buckets = TM_SHARED_READ(hashtablePtr->buckets);
+    pair_t* pairPtr = (pair_t*)TMLIST_FIND(TM_SHARED_READ(buckets[i]), &findPair);
+#else
     pair_t* pairPtr = (pair_t*)TMLIST_FIND(hashtablePtr->buckets[i], &findPair);
+#endif
     if (pairPtr != NULL) {
         return FALSE;
     }
@@ -738,15 +858,47 @@
         return FALSE;
     }
 
+#ifdef HASHTABLE_SIZE_FIELD
+    newSize = TM_SHARED_READ(hashtablePtr->size) + 1;
+    assert(newSize > 0);
+#elif defined(HASHTABLE_RESIZABLE)
+    newSize = TMHASHTABLE_GETSIZE(hashtablePtr) + 1;
+    assert(newSize > 0);
+#endif
+
+#ifdef HASHTABLE_RESIZABLE
+    /* Increase number of buckets to maintain size ratio */
+    if (newSize >= (numBucket * hashtablePtr->resizeRatio)) {
+        list_t** newBuckets = TMrehash(TM_ARG  hashtablePtr);
+        if (newBuckets == NULL) {
+            return FALSE;
+        }
+        TMfreeBuckets(TM_ARG  hashtablePtr->buckets, numBucket);
+        numBucket *= hashtablePtr->growthFactor;
+	TM_SHARED_WRITE(hashtablePtr->buckets, newBuckets);
+        TM_SHARED_WRITE(hashtablePtr->numBucket, numBucket);
+        i = hashtablePtr->hash(keyPtr) % numBucket;
+
+    }
+#endif
+
     /* Add new entry  */
+#ifdef HASHTABLE_SIZE_FIELD
+    buckets = TM_SHARED_READ(hashtablePtr->buckets);
+    if (TMLIST_INSERT(TM_SHARED_READ(buckets[i]), insertPtr) == FALSE) {
+        TMPAIR_FREE(insertPtr);
+        return FALSE;
+    }
+#else
     if (TMLIST_INSERT(hashtablePtr->buckets[i], insertPtr) == FALSE) {
         TMPAIR_FREE(insertPtr);
         return FALSE;
     }
+#endif
 
 #ifdef HASHTABLE_SIZE_FIELD
-    long newSize = TM_SHARED_READ(hashtablePtr->size) + 1;
-    assert(newSize > 0);
+    /*long newSize = TM_SHARED_READ(hashtablePtr->size) + 1;
+    assert(newSize > 0);*/
     TM_SHARED_WRITE(hashtablePtr->size, newSize);
 #endif
 
@@ -812,7 +964,7 @@
     TMPAIR_FREE(pairPtr);
 
 #ifdef HASHTABLE_SIZE_FIELD
-    TM_SHARED_WRITE(hashtablePtr->size
+    TM_SHARED_WRITE(hashtablePtr->size,
                     (long)TM_SHARED_READ(hashtablePtr->size)-1);
     assert(hashtablePtr->size >= 0);
 #endif
diff -Naur -x .svn stamp-0.9.10/lib/hashtable.h stamp-0.9.10_Distribute/lib/hashtable.h
--- stamp-0.9.10/lib/hashtable.h	2008-09-09 07:42:39.000000000 +0900
+++ stamp-0.9.10_Distribute/lib/hashtable.h	2014-12-18 12:21:33.726755408 +0900
@@ -79,6 +79,7 @@
  *
  * =============================================================================
  */
+/* Copyright (c) IBM Corp. 2014. */
 
 
 #ifndef HASHTABLE_H
@@ -185,6 +186,13 @@
                  long resizeRatio,
                  long growthFactor);
 
+int
+hashtable_init (hashtable_t* hashtablePtr,
+		long initNumBucket,
+		ulong_t (*hash)(const void*),
+		long (*comparePairs)(const pair_t*, const pair_t*),
+		long resizeRatio,
+		long growthFactor);
 
 /* =============================================================================
  * TMhashtable_alloc
@@ -200,6 +208,15 @@
                    long resizeRatio,
                    long growthFactor);
 
+int
+TMhashtable_init (TM_ARGDECL
+		  hashtable_t* hashtablePtr,
+		  long initNumBucket,
+		  ulong_t (*hash)(const void*),
+		  long (*comparePairs)(const pair_t*, const pair_t*),
+		  long resizeRatio,
+		  long growthFactor);
+
 
 /* =============================================================================
  * hashtable_free
@@ -208,6 +225,9 @@
 void
 hashtable_free (hashtable_t* hashtablePtr);
 
+void
+hashtable_free_buckets (hashtable_t* hashtablePtr);
+
 
 /* =============================================================================
  * TMhashtable_free
@@ -216,6 +236,9 @@
 void
 TMhashtable_free (TM_ARGDECL  hashtable_t* hashtablePtr);
 
+void
+TMhashtable_free_buckets (TM_ARGDECL  hashtable_t* hashtablePtr);
+
 
 /* =============================================================================
  * hashtable_isEmpty
@@ -329,7 +352,7 @@
 #define TMHASHTABLE_GETSIZE(ht)           TMhashtable_getSize(TM_ARG  ht)
 #define TMHASHTABLE_FIND(ht, k)           TMhashtable_find(TM_ARG  ht, k)
 #define TMHASHTABLE_INSERT(ht, k, d)      TMhashtable_insert(TM_ARG  ht, k, d)
-#define TMHASHTABLE_REMOVE(ht)            TMhashtable_remove(TM_ARG  ht)
+#define TMHASHTABLE_REMOVE(ht, k)         TMhashtable_remove(TM_ARG  ht, k)
 
 
 #ifdef __cplusplus
diff -Naur -x .svn stamp-0.9.10/lib/hle_intel.c stamp-0.9.10_Distribute/lib/hle_intel.c
--- stamp-0.9.10/lib/hle_intel.c	1970-01-01 09:00:00.000000000 +0900
+++ stamp-0.9.10_Distribute/lib/hle_intel.c	2014-12-18 12:21:39.352692862 +0900
@@ -0,0 +1,100 @@
+/* Copyright (c) IBM Corp. 2014. */
+/* Code that uses Intel Hardware Lock Elision: derived from htm_ibm.c */
+#include <stdio.h>
+#include <stdlib.h>
+#include <string.h>
+#include <inttypes.h>
+#include <unistd.h>
+#include <immintrin.h>
+#include "hle_intel.h"
+#include "thread.h"
+
+#define NUM_ATOMIC_REGIONS 20
+
+int global_lock;
+static THREAD_KEY_T global_tls_key;
+typedef struct event_counters_struct {
+	unsigned long long event_tx_enter;
+	unsigned long long event_tx;
+} event_counters_t;
+typedef struct tls_struct {
+	event_counters_t event_counters[NUM_ATOMIC_REGIONS];
+} tls_t;
+static event_counters_t global_event_counters;
+static event_counters_t global_ctr_per_region[NUM_ATOMIC_REGIONS];
+static int global_evt_ctrs_lock = 0;
+
+void tm_startup_hle() {
+	__atomic_store_n(&global_lock,0,__ATOMIC_RELEASE);
+	THREAD_KEY_INIT(global_tls_key);
+	
+	memset(&global_event_counters,0,sizeof(global_event_counters));
+	memset(&global_ctr_per_region,0,sizeof(global_ctr_per_region));
+}
+
+static void print_stats_hle(event_counters_t *stats) {
+	fprintf(stderr, "#HTM_STATS %15llu           tx_enter\n", stats->event_tx_enter);
+	fprintf(stderr, "#HTM_STATS %15llu %6.2f %%  tx\n", stats->event_tx, 100 * stats->event_tx / (double)stats->event_tx_enter);
+}
+
+void tm_shutdown_hle() {
+	int region;
+	for(region=0; region<NUM_ATOMIC_REGIONS; region++) {
+		global_event_counters.event_tx_enter+=global_ctr_per_region[region].event_tx_enter;
+		global_event_counters.event_tx+=global_ctr_per_region[region].event_tx;
+	}
+	print_stats_hle(&global_event_counters);
+	for(region=0; region<NUM_ATOMIC_REGIONS; region++) {
+		if(global_ctr_per_region[region].event_tx_enter) {
+			fprintf(stderr, "--- region %d ------------------------------\n", region);
+			print_stats_hle(&global_ctr_per_region[region]);
+		}
+	}
+}
+
+void tm_thread_enter_hle() {
+	tls_t *tls;
+	if(!(tls=malloc(sizeof(tls_t)))) {
+		perror("malloc tls");
+		exit(1);
+	}
+	memset(tls,0,sizeof(tls_t));
+	THREAD_KEY_SET(global_tls_key,tls);
+}
+
+void tm_thread_exit_hle() {
+	tls_t *tls;
+	tls=THREAD_KEY_GET(global_tls_key);
+	int region;
+	/* Lock Global counters */
+	while(__atomic_exchange_n(&global_evt_ctrs_lock,1,__ATOMIC_ACQUIRE|__ATOMIC_HLE_ACQUIRE))
+		_mm_pause();
+	for(region=0; region<NUM_ATOMIC_REGIONS; region++) {
+		global_ctr_per_region[region].event_tx_enter += tls->event_counters[region].event_tx_enter;
+		global_ctr_per_region[region].event_tx += tls->event_counters[region].event_tx;
+	}
+	/* unlock global counters */
+	__atomic_store_n(&global_evt_ctrs_lock,0,__ATOMIC_RELEASE|__ATOMIC_HLE_RELEASE);
+	free(tls);
+}
+
+void tbegin_hle(int region_id) {
+	tls_t *tls;
+	tls=THREAD_KEY_GET(global_tls_key);
+	tls->event_counters[region_id].event_tx_enter++;
+	while(__atomic_exchange_n(&global_lock,1,__ATOMIC_ACQUIRE|__ATOMIC_HLE_ACQUIRE))
+		_mm_pause();
+	if(!_xtest()) {
+		tls->event_counters[region_id].event_tx++;
+	}
+	return;
+}
+
+void tend_hle() {
+	__atomic_store_n(&global_lock,0,__ATOMIC_RELEASE|__ATOMIC_HLE_RELEASE);
+}
+
+void tabort_hle() {
+  asm volatile(".byte 0xc6; .byte 0xf8; .byte 0xff" :: );
+  /*__builtin_ia32_xabort(0xff);*/
+}
diff -Naur -x .svn stamp-0.9.10/lib/hle_intel.h stamp-0.9.10_Distribute/lib/hle_intel.h
--- stamp-0.9.10/lib/hle_intel.h	1970-01-01 09:00:00.000000000 +0900
+++ stamp-0.9.10_Distribute/lib/hle_intel.h	2014-12-18 12:21:43.566568089 +0900
@@ -0,0 +1,15 @@
+/* Copyright (c) IBM Corp. 2014. */
+#ifndef HLE_INTEL_H
+#define HLE_INTEL_H 1
+
+extern void tm_startup_hle();
+extern void tm_shutdown_hle();
+
+extern void tm_thread_enter_hle();
+extern void tm_thread_exit_hle();
+
+extern void tbegin_hle(int region_id);
+extern void tend_hle();
+extern void tabort_hle();
+
+#endif
diff -Naur -x .svn stamp-0.9.10/lib/htm_ia32_stat.h stamp-0.9.10_Distribute/lib/htm_ia32_stat.h
--- stamp-0.9.10/lib/htm_ia32_stat.h	1970-01-01 09:00:00.000000000 +0900
+++ stamp-0.9.10_Distribute/lib/htm_ia32_stat.h	2014-12-18 12:21:49.350786634 +0900
@@ -0,0 +1,8 @@
+/* Copyright (c) IBM Corp. 2014. */
+HTM_IA32_STAT(GLOBAL_LOCK_ACQUIRED)
+HTM_IA32_STAT(XABORT)
+HTM_IA32_STAT(TRANSIENT)
+HTM_IA32_STAT(MEMADDR_CONFLICT)
+HTM_IA32_STAT(BUFFER_OVERFLOW)
+HTM_IA32_STAT(HIT_DEBUG_BREAKPOINT)
+HTM_IA32_STAT(DURING_NESTED_TRANSACTION)
